//  Beispiel 16.1: MQTT-Test
//
//  Unter Verwendung der IoT Brick Library

#include <all_IoT.h>
#include <all_MQTT.h>


int counter = 0;


void setup()
{
  IoT_Init(true);
  IoT_TerminalWaitInit(true);
  IoT_WLANautoConnect(true);                                        // Verbindung, ggf. gespeicherte, über WLAN herstellen
  IoT_NTPinit();                                                    // NTP-Timeserver initialisieren
  
  IoT_DisplayClear(24);                                             // OLED Display löschen (24 Punkt Schrift)
  IoT_DisplayAlignText(TEXT_ALIGN_CENTER);                          // Zentrierte Darstellung des Textes
  IoT_DisplayDrawText(64, 5, "Suche mqtt");
  IoT_DisplayDrawText(64, 34, "Server...");
  IoT_DisplayUpdate();                                              // OLED-Anzeige aktualisieren

  MQTT_Init("broker.mqtt-dashboard.com", 1883, newuniqueid(), "", "");
  MQTT_Connect("test");

  MQTT_Init("broker.hivemq.com", 1883, "BrickRknowledge", "", "");
  MQTT_Connect("alpha/a");

  MQTT_Init("mqtt.mydevices.com", 1883, "82410050-608e-11e7-a041-7d8fa03d7b64",
            "9d7e33d0-a71e-11e6-839f-8bfd46afe676", "c4f99459f8f214cf1bc0c600d22e52c661157022");
  MQTT_Connect("general/data/#");

  MQTT_Init(IPval("212.18.29.166"), 1883, "BrickRknowledge", "open", "Allnet"); // iot.allnet.de = IPval("212.18.29.166") ("open",  "Allnet")
  MQTT_Connect("general/data/#");

  MQTT_Init("iot.allnet.de", 1883, "BrickRknowledge", "open", "Allnet"); // iot.allnet.de = IPval("212.18.29.166") ("open",  "Allnet")
  MQTT_Connect("general/data/#");
}

void loop()
{
  IoT_Idle();

  if (IoT_Keypress())                                               // Wenn Taster gedrückt wird, Konfiguration zeigen
  {
    IoT_DisplayWLANstatus();
    IoT_DisplayUpdate();                                            // OLED-Anzeige aktualisieren
    Serial.println(IoT_NTPdatetime() + " (" + IoT_NTPdaylightSavingTime(true) + ")");
    Serial.print("WiFi is ");
    Serial.print(IoT_WLANconnected() ? "connected" : "not connected");
    Serial.println(". Uptime: " + IoT_WLANuptime(true) + " seit " + IoT_WLANstartDatetime());
    IoT_WaitNoKeypress();
  }
  else
  {
    IoT_Idle();
    if (counter % 25 == 0) //Infos seriell nicht zu oft ausgeben (ca. alle 2 Sekunden)
    {
      if (IoT_NTPeventAvail)                                        // Zeitevent triggern
      {
        IoT_NTPprintEvent(IoT_NTPcurrentEvent);
        IoT_NTPeventAvail = false;
      }
    }
    
    IoT_DisplayClear(16);                                           // OLED Display löschen (16 Punkt Schrift)
    IoT_DisplayAlignText(TEXT_ALIGN_CENTER);                        // Zentrierte Darstellung des Textes
    if (IoT_WLANinited)
    {
      IoT_DisplayClear(24);                                         // OLED Display löschen (24 Punkt Schrift)
      if (MQTT_Client.connected())
      {
        IoT_DisplayAlignText(TEXT_ALIGN_CENTER);                    // Zentrierte Darstellung des Textes
        IoT_DisplayDrawText(64, 5, "Verbunden");
        IoT_DisplayDrawText(64, 34, "mit mqtt");
      }
      else
      {
        IoT_DisplayAlignText(TEXT_ALIGN_CENTER);                    // Zentrierte Darstellung des Textes
        IoT_DisplayDrawText(64, 5, "Suche mqtt");
        IoT_DisplayDrawText(64, 34, "Server...");
      }
      IoT_DisplayUpdate();                                          // OLED-Anzeige aktualisieren
    }
    else
    {
      IoT_DisplayClear(24);                                         // OLED Display löschen (24 Punkt Schrift)
      IoT_DisplayAlignText(TEXT_ALIGN_CENTER);                      // Zentrierte Darstellung des Textes
      IoT_DisplayDrawText(64, 5, "Kein");
      IoT_DisplayDrawText(64, 34, "WLAN");
    }
  }
  IoT_DisplayUpdate();                                              // OLED-Anzeige aktualisieren

  bool success = MQTT_HandleClient();                               // Verbindung aufrecht erhalten, ggf. neu aufbauen

  if (MQTT_EventAvail)
  {
    MQTT_GetNextEvent();
    Serial.println("");
    Serial.print("Time: "      + cleanasc(String(MQTT_EventCurrentTime)));
    Serial.println(", Topic: " + cleanasc(String(MQTT_EventCurrentTopic)));
    Serial.println("Message: " + String(MQTT_EventCurrentMessage));
  }
  else
  {
    if (MQTT_Client.connected())
    {
      Serial.print(".");
    }
    else
    {
      Serial.print("?");
    }
    delay(1000);                                                    // 1 Sekunde warten
    t_TerminalRead();                                               // Reset-Anforderung prüfen
  }
  
  counter++;
}

